
variable "accounts" {
  type        = list(map(string))
  description = "A list mapping used to add multiple accounts. Each item supports keys: account_name, account_password, account_type (default to Normal) and account_privilege (default to RoleReadOnly)."
  default     = []
}

variable "alarm_rule_contact_groups" {
  type        = list(string)
  description = "List contact groups of the alarm rule, which must have been created on the console. "
  default     = []
}

variable "alarm_rule_effective_interval" {
  type        = string
  description = "The interval of effecting alarm rule. It foramt as 'hh:mm-hh:mm', like '0:00-4:00'."
  default     = "0:00-2:00"
}

variable "alarm_rule_name" {
  type        = string
  description = "The alarm rule name. "
  default     = ""
}

variable "alarm_rule_operator" {
  type        = string
  description = "Alarm comparison operator. Valid values: ['<=', '<', '>', '>=', '==', '!=']. Default to '=='. "
  default     = "=="
}

variable "alarm_rule_period" {
  type        = number
  description = "Index query cycle, which must be consistent with that defined for metrics. Default to 300, in seconds. "
  default     = 300
}

variable "alarm_rule_silence_time" {
  type        = number
  description = "Notification silence period in the alarm state, in seconds. Valid value range: [300, 86400]. Default to 86400. "
  default     = 86400
}

variable "alarm_rule_statistics" {
  type        = string
  description = "Statistical method. It must be consistent with that defined for metrics. Valid values: ['Average', 'Minimum', 'Maximum']. Default to 'Average'. "
  default     = "Average"
}

variable "alarm_rule_threshold" {
  type        = string
  description = "Alarm threshold value, which must be a numeric value currently. "
  default     = ""
}

variable "alarm_rule_triggered_count" {
  type        = number
  description = "Number of consecutive times it has been detected that the values exceed the threshold. Default to 3. "
  default     = 3
}

variable "auto_renew" {
  type        = bool
  description = "Whether to renewal a DB instance automatically or not. It is valid when instance_charge_type is PrePaid. Default to false."
  default     = false
}

variable "auto_renew_period" {
  type        = number
  description = "Auto-renewal period of an instance, in the unit of the month. It is valid when instance_charge_type is PrePaid. Valid value:[1~12], Default to 1."
  default     = 1
}

variable "availability_zone" {
  type        = string
  description = "The available zone to launch Redis instance and other resources."
  default     = ""
}

variable "backup_policy_backup_period" {
  type        = list(string)
  description = "Redis Instance backup policy backup period."
  default     = []
}

variable "backup_policy_backup_time" {
  type        = string
  description = "Redis instance backup policy backup time, in the format of HH:mmZ- HH:mmZ."
  default     = "02:00Z-03:00Z"
}

variable "config" {
  type        = map(string)
  description = "The configuration of the KVStore DBInstance."
  default     = {}
}

variable "create_account" {
  type        = bool
  description = "Whether to create a new account. If true, the 'accounts' should not be empty."
  default     = true
}

variable "create_instance" {
  type        = bool
  description = "Whether to create Redis instance. If false, you can use a existing Redis instance by setting `existing_instance_id`."
  default     = true
}

variable "enable_alarm_rule" {
  type        = bool
  description = "Whether to enable alarm rule. Default to true. "
  default     = true
}

variable "engine_version" {
  type        = string
  description = "Redis version. Value options can refer to the latest docs [CreateInstance](https://help.aliyun.com/document_detail/60862.html?spm=a2c4g.11186623.6.770.e0c735c10lvrqR) "
  default     = ""
}

variable "existing_instance_id" {
  type        = string
  description = "The Id of an existing redis instance. If set, the `create_instance` will be ignored."
  default     = ""
}

variable "instance_backup_id" {
  type        = string
  description = "If an instance created based on a backup set generated by another instance is valid, this parameter indicates the ID of the generated backup set"
  default     = ""
}

variable "instance_charge_type" {
  type        = string
  description = "Filter the results by charge type. Valid values: PrePaid and PostPaid. Default to PostPaid."
  default     = "PostPaid"
}

variable "instance_class" {
  type        = string
  description = "Redis instance type. Refer the Redis instance type reference, such as 'redis.master.small.default', 'redis.master.4xlarge.default', 'redis.sharding.mid.default' etc"
  default     = ""
}

variable "instance_name" {
  type        = string
  description = "Display name of the instance, [2, 128] English or Chinese characters, must start with a letter or Chinese in size, can contain numbers, '_' or '.', '-'"
  default     = ""
}

variable "instance_release_protection" {
  type        = bool
  description = "Whether to open the release protection."
  default     = false
}

variable "kms_encrypted_password" {
  type        = string
  description = "An KMS encrypts password used to an instance. It is conflicted with 'password'."
  default     = ""
}

variable "kms_encryption_context" {
  type        = map(string)
  description = "An KMS encryption context used to decrypt `kms_encrypted_password` before creating or updating an instance with 'kms_encrypted_password'."
  default     = {}
}

variable "maintain_end_time" {
  type        = string
  description = "The end time of the operation and maintenance time period of the instance, in the format of HH:mmZ (UTC time)."
  default     = "03:00Z"
}

variable "maintain_start_time" {
  type        = string
  description = "The start time of the operation and maintenance time period of the instance, in the format of HH:mmZ (UTC time)."
  default     = "02:00Z"
}

variable "password" {
  type        = string
  description = "The password of the redis instance."
  default     = ""
}

variable "period" {
  type        = number
  description = "The duration that you will buy DB instance (in month). It is valid when instance_charge_type is PrePaid. Valid values: [1~9], 12, 24, 36. Default to 1"
  default     = 1
}

variable "private_ip" {
  type        = string
  description = "Set the instance's private IP."
  default     = ""
}

variable "profile" {
  type        = string
  description = "(Deprecated from version 1.3.0)The profile name as set in the shared credentials file. If not set, it will be sourced from the ALICLOUD_PROFILE environment variable."
  default     = ""
}

variable "region" {
  type        = string
  description = "(Deprecated from version 1.3.0)The region used to launch this module resources."
  default     = ""
}

variable "secondary_zone_id" {
  type        = string
  description = "The ID of the secondary zone to which you want to migrate the ApsaraDB for Redis instance. If you specify this parameter, the master node and replica node of the instance can be deployed in different zones and disaster recovery is implemented across zones. The instance can withstand failures in data centers."
  default     = ""
}

variable "security_group_id" {
  type        = string
  description = "The ID of security groups. You can specify up to 10 security_group_id. Separate multiple security group IDs with commas (,), such as sg-***,sg-***,sg-***."
  default     = ""
}

variable "security_ips" {
  type        = list(string)
  description = "List of IP addresses allowed to access all redis of an instance. The list contains up to 1,000 IP addresses, separated by commas. Supported formats include 0.0.0.0/0, 10.23.12.24 (IP), and 10.23.12.24/24 (Classless Inter-Domain Routing (CIDR) mode. /24 represents the length of the prefix in an IP address. The range of the prefix length is [1,32])."
  default     = []
}

variable "shared_credentials_file" {
  type        = string
  description = "(Deprecated from version 1.3.0)This is the path to the shared credentials file. If this is not set and a profile is specified, $HOME/.aliyun/config.json will be used."
  default     = ""
}

variable "skip_region_validation" {
  type        = bool
  description = "(Deprecated from version 1.3.0)Skip static validation of region ID. Used by users of alternative AlibabaCloud-like APIs or users w/ access to regions that are not public (yet)."
  default     = false
}

variable "ssl_enable" {
  type        = string
  description = "Modifies the SSL status. Valid values: `Disable`, `Enable` and `Update`."
  default     = ""
}

variable "tags" {
  type        = map(string)
  description = "A mapping of tags to assign to the redis instance resource."
  default     = {}
}

variable "vpc_auth_mode" {
  type        = string
  description = "Only meaningful if instance_type is Redis and network type is VPC. Valid values are Close, Open. Defaults to Open. Close means the redis instance can be accessed without authentication. Open means authentication is required."
  default     = "Open"
}

variable "vswitch_id" {
  type        = string
  description = "The vswitch id used to launch one or more instances."
  default     = ""
}

